Subject: [OSPF] OSPF TE Attribute Binding to Applications Dynamicity

From: "Acee Lindem (acee)" <[email-masked]>
Date: Tue, 16 May 2017 21:16:52 +0000

At the OSPF WG meeting in Chicago, Stephane Litkowski expressed the desire to have a more dynamic mechanism for binding attributes to applications. I’ve thought about this for some time and see the following potential use cases.

    1. Usage for an application prior to early IANA allocation of a bit position for that application.
    2. Usage for user applications that will never be standardized but still require link (and potentially prefix) attributes.

Are there any others?

An application tagging mechanism was suggested for this purpose. However, I still believe the bit-mask encoding can satisfy these use cases.

The first requirement could be satisfied by allocating some number of experimental bit positions in the initial bit mask specification. These could be used for experimental applications prior to IANA early allocation. Similarly, the second requirement could be satisfied by allocating some number of user-application bit positions in the initial bit-mask allocation. I really don’t see significant advantage of a tag over a bit position as, no matter what mechanism is used, all the OSPF routers in the routing domain will need to agree on what bit/tag corresponds to what application. For the first use case, this would be decided among the implementors supporting the experimental application while in the second use case, the application binding would likely need to be configured.

The only argument I could see for a application tag would be that you need too many bits of either type (experimental or user applications). In this case, we could still use a bit mask in the OSPF Prefix/Link Attribute LSA and advertise the application identifier (i.e., tag) to bit position mappings in the OSPF Router Information LSAs. However, I don’t think this level of indirection is necessary.

Thanks,
Acee